#!/usr/bin/env python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
# +------------------------------------------------------------------+
# |             ____ _               _        __  __ _  __           |
# |            / ___| |__   ___  ___| | __   |  \/  | |/ /           |
# |           | |   | '_ \ / _ \/ __| |/ /   | |\/| | ' /            |
# |           | |___| | | |  __/ (__|   <    | |  | | . \            |
# |            \____|_| |_|\___|\___|_|\_\___|_|  |_|_|\_\           |
# |                                                                  |
# | Copyright Mathias Kettner 2014             mk@mathias-kettner.de |
# +------------------------------------------------------------------+
#
# This file is part of Check_MK.
# The official homepage is at http://mathias-kettner.de/check_mk.
#
# check_mk is free software;  you can redistribute it and/or modify it
# under the  terms of the  GNU General Public License  as published by
# the Free Software Foundation in version 2.  check_mk is  distributed
# in the hope that it will be useful, but WITHOUT ANY WARRANTY;  with-
# out even the implied warranty of  MERCHANTABILITY  or  FITNESS FOR A
# PARTICULAR PURPOSE. See the  GNU General Public License for more de-
# tails. You should have  received  a copy of the  GNU  General Public
# License along with GNU Make; see the file  COPYING.  If  not,  write
# to the Free Software Foundation, Inc., 51 Franklin St,  Fifth Floor,
# Boston, MA 02110-1301 USA.
"""Main entry page for configuration of global variables, rules, groups,
timeperiods, users, etc."""

from cmk.gui.i18n import _

from cmk.gui.plugins.wato.utils.main_menu import (
    MainMenu,
    get_modules,
)

from cmk.gui.plugins.wato import (
    WatoMode,
    mode_registry,
    changelog_button,
)


@mode_registry.register
class ModeMain(WatoMode):
    @classmethod
    def name(cls):
        return "main"

    @classmethod
    def permissions(cls):
        return []

    def title(self):
        return _("WATO - Check_MK's Web Administration Tool")

    def buttons(self):
        changelog_button()

    def page(self):
        MainMenu(get_modules()).show()
